# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SupervisorNamespaceUpdateDTO(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'resource_quotas': 'list[CmxapiresourcessupervisornamespacesnamespaceSelfLinkIdregisterResourceQuotas]',
        'storage_policies': 'list[CmxapiresourcessupervisornamespacesStoragePolicies]'
    }

    attribute_map = {
        'description': 'description',
        'resource_quotas': 'resourceQuotas',
        'storage_policies': 'storagePolicies'
    }

    def __init__(self, description=None, resource_quotas=None, storage_policies=None):  # noqa: E501
        """SupervisorNamespaceUpdateDTO - a model defined in Swagger"""  # noqa: E501
        self._description = None
        self._resource_quotas = None
        self._storage_policies = None
        self.discriminator = None
        if description is not None:
            self.description = description
        if resource_quotas is not None:
            self.resource_quotas = resource_quotas
        if storage_policies is not None:
            self.storage_policies = storage_policies

    @property
    def description(self):
        """Gets the description of this SupervisorNamespaceUpdateDTO.  # noqa: E501


        :return: The description of this SupervisorNamespaceUpdateDTO.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this SupervisorNamespaceUpdateDTO.


        :param description: The description of this SupervisorNamespaceUpdateDTO.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def resource_quotas(self):
        """Gets the resource_quotas of this SupervisorNamespaceUpdateDTO.  # noqa: E501


        :return: The resource_quotas of this SupervisorNamespaceUpdateDTO.  # noqa: E501
        :rtype: list[CmxapiresourcessupervisornamespacesnamespaceSelfLinkIdregisterResourceQuotas]
        """
        return self._resource_quotas

    @resource_quotas.setter
    def resource_quotas(self, resource_quotas):
        """Sets the resource_quotas of this SupervisorNamespaceUpdateDTO.


        :param resource_quotas: The resource_quotas of this SupervisorNamespaceUpdateDTO.  # noqa: E501
        :type: list[CmxapiresourcessupervisornamespacesnamespaceSelfLinkIdregisterResourceQuotas]
        """

        self._resource_quotas = resource_quotas

    @property
    def storage_policies(self):
        """Gets the storage_policies of this SupervisorNamespaceUpdateDTO.  # noqa: E501


        :return: The storage_policies of this SupervisorNamespaceUpdateDTO.  # noqa: E501
        :rtype: list[CmxapiresourcessupervisornamespacesStoragePolicies]
        """
        return self._storage_policies

    @storage_policies.setter
    def storage_policies(self, storage_policies):
        """Sets the storage_policies of this SupervisorNamespaceUpdateDTO.


        :param storage_policies: The storage_policies of this SupervisorNamespaceUpdateDTO.  # noqa: E501
        :type: list[CmxapiresourcessupervisornamespacesStoragePolicies]
        """

        self._storage_policies = storage_policies

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SupervisorNamespaceUpdateDTO, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SupervisorNamespaceUpdateDTO):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
